RB = {}
RB.name = "RaidBuffsTank"
boss1 = false
boss2 = false
boss3 = false 
debug = false

-- Important Buffs:
-- The Morag Tong:	34384
-- Night Mother's Gaze: 34386
-- Sunderflame:		60416
-- Crusher:		17906
-- Alkosh:		75753
-- Minor Vulnerability:	81519
-- Power of the Light:	27587
-- Off-Balance:		62988 63108 63003
-- OB Immunity:		102771
-- Engulfing:		34050

function RB.Init()
  EVENT_MANAGER:RegisterForEvent(RB.name, EVENT_BOSSES_CHANGED, RB.BossUpdate)
  EVENT_MANAGER:RegisterForEvent(RB.name, EVENT_ZONE_CHANGED, RB.BossUpdate)
  EVENT_MANAGER:RegisterForEvent(RB.name, EVENT_ZONE_UPDATE, RB.BossUpdate)
  RB.savedVariables = ZO_SavedVars:New("RBTSavedVariables", 1, nil, {})
  RB.RestorePosition()
  EVENT_MANAGER:RegisterForUpdate('RBTUpdate', 200, RB.buffUpdate)
  RB.BossUpdate()
end

function RB.OnIndicatorMoveStop()
    RB.savedVariables.left = BossFrame:GetLeft()
    RB.savedVariables.top = BossFrame:GetTop()
    RB.RestorePosition()
end

function RB.RestorePosition()
  if RB.savedVariables.left and RB.savedVariables.top then
    local left = RB.savedVariables.left
    local top = RB.savedVariables.top

    BossFrame:ClearAnchors()
    BossFrame:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, left, top)
    BossFrame2:ClearAnchors()
    BossFrame2:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, left, top+58)
    BossFrame3:ClearAnchors()
    BossFrame3:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, left, top+116)
  else
    local left = 100
    local top = 100

    BossFrame:ClearAnchors()
    BossFrame:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, left, top)
    BossFrame2:ClearAnchors()
    BossFrame2:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, left, top+58)
    BossFrame3:ClearAnchors()
    BossFrame3:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, left, top+116)
  end
end

function RB.time(nd)
  local time = math.floor((nd - GetGameTimeMilliseconds()/1000) * 10 + 0.5)/10
  return time
end

function RB.BossUpdate()
  if DoesUnitExist('boss1') == true then
    BossFrameBoss1:SetText(GetUnitName('boss1'))
    BossFrame:SetHidden(false)
    boss1 = true
  else
    BossFrameBoss1:SetText('')
    BossFrame:SetHidden(true)
    boss1 = false
  end

  if DoesUnitExist('boss2') == true then
    BossFrame2Boss2:SetText(GetUnitName('boss2'))
    BossFrame2:SetHidden(false)
    boss2 = true
  else
    BossFrame2Boss2:SetText('')
    BossFrame2:SetHidden(true)
    boss2 = false
  end

  if DoesUnitExist('boss3') == true then
    BossFrame3Boss3:SetText(GetUnitName('boss3'))
    BossFrame3:SetHidden(false)
    boss3 = true
  else
    BossFrame3Boss3:SetText('')
    BossFrame3:SetHidden(true)
    boss3 = false
  end
end

function RB.buffUpdate()
  if boss1 == true then
    local updates = {false, false, false}
    local b1NumBuffs = GetNumBuffs('boss1')
    for i = 1, b1NumBuffs do
      local _,_,nd,_,_,_,_,_,_,_,ID = GetUnitBuffInfo('boss1',i)
      if ID == 75753 then 	-- alkosh
        BossFrameB1AlkoshTime:SetText(string.format('%.1f',RB.time(nd)))
        updates[1] = true
      elseif ID == 17906 then	-- crusher
        BossFrameB1CrusherTime:SetText(string.format('%.1f',RB.time(nd)))
        updates[2] = true
      elseif ID == 34050 then	-- engulfing flames
        BossFrameB1EngulfingTime:SetText(string.format('%.1f',RB.time(nd)))
        updates[3] = true
      end

    end
    if updates[1] == true then	-- alkosh
      BossFrameB1Alkosh:SetColor(0, 255, 0)
    else
      BossFrameB1Alkosh:SetColor(255, 255, 255)
      BossFrameB1AlkoshTime:SetText('0.0')
    end
    if updates[2] == true then	-- crusher
      BossFrameB1Crusher:SetColor(0, 255, 0)
    else
      BossFrameB1Crusher:SetColor(255, 255, 255)
      BossFrameB1CrusherTime:SetText('0.0')
    end
    if updates[3] == true then	-- engulfing
      BossFrameB1Engulfing:SetColor(0, 255, 0)
    else
      BossFrameB1Engulfing:SetColor(255, 255, 255)
      BossFrameB1EngulfingTime:SetText('0.0')
    end
  end

  if boss2 == true then
    local updates = {false, false, false}
    local b2NumBuffs = GetNumBuffs('boss2')
    for i = 1, b2NumBuffs do
      local _,_,nd,_,_,_,_,_,_,_,ID = GetUnitBuffInfo('boss2',i)
      if ID == 75753 then 	-- alkosh
        BossFrame2B2AlkoshTime:SetText(string.format('%.1f',RB.time(nd)))
        updates[1] = true
      elseif ID == 17906 then	-- crusher
        BossFrame2B2CrusherTime:SetText(string.format('%.1f',RB.time(nd)))
        updates[2] = true
      elseif ID == 34050 then	-- engulfing flames
        BossFrame2B2EngulfingTime:SetText(string.format('%.1f',RB.time(nd)))
        updates[3] = true
      end

    end
    if updates[1] == true then	-- alkosh
      BossFrame2B2Alkosh:SetColor(0, 255, 0)
    else
      BossFrame2B2Alkosh:SetColor(255, 255, 255)
      BossFrame2B2AlkoshTime:SetText('0.0')
    end
    if updates[2] == true then	-- crusher
      BossFrame2B2Crusher:SetColor(0, 255, 0)
    else
      BossFrame2B2Crusher:SetColor(255, 255, 255)
      BossFrame2B2CrusherTime:SetText('0.0')
    end
    if updates[3] == true then	-- engulfing
      BossFrame2B2Engulfing:SetColor(0, 255, 0)
    else
      BossFrame2B2Engulfing:SetColor(255, 255, 255)
      BossFrame2B2EngulfingTime:SetText('0.0')
    end
  end

  if boss3 == true then
    local updates = {false, false, false}
    local b3NumBuffs = GetNumBuffs('boss3')
    for i = 1, b3NumBuffs do
      local _,_,nd,_,_,_,_,_,_,_,ID = GetUnitBuffInfo('boss3',i)
      if ID == 75753 then 	-- alkosh
        BossFrame3B3AlkoshTime:SetText(string.format('%.1f',RB.time(nd)))
        updates[1] = true
      elseif ID == 17906 then	-- crusher
        BossFrame3B3CrusherTime:SetText(string.format('%.1f',RB.time(nd)))
        updates[2] = true
      elseif ID == 34050 then	-- engulfing flames
        BossFrame3B3EngulfingTime:SetText(string.format('%.1f',RB.time(nd)))
        updates[3] = true
      end

    end
    if updates[1] == true then	-- alkosh
      BossFrame3B3Alkosh:SetColor(0, 255, 0)
    else
      BossFrame3B3Alkosh:SetColor(255, 255, 255)
      BossFrame3B3AlkoshTime:SetText('0.0')
    end
    if updates[2] == true then	-- crusher
      BossFrame3B3Crusher:SetColor(0, 255, 0)
    else
      BossFrame3B3Crusher:SetColor(255, 255, 255)
      BossFrame3B3CrusherTime:SetText('0.0')
    end
    if updates[3] == true then	-- engulfing
      BossFrame3B3Engulfing:SetColor(0, 255, 0)
    else
      BossFrame3B3Engulfing:SetColor(255, 255, 255)
      BossFrame3B3EngulfingTime:SetText('0.0')
    end
  end
end

function setup()
  if debug == false then
    BossFrame:SetHidden(false)
    BossFrame2:SetHidden(false)
    BossFrame3:SetHidden(false)
    debug = true
  else
    BossFrame:SetHidden(true)
    BossFrame2:SetHidden(true)
    BossFrame3:SetHidden(true)
    debug = false
  end
end
  
SLASH_COMMANDS["/togglesetup"] = setup


function RB.onAddonLoaded(event, addonName)
  if addonName == RB.name then
    zo_callLater(function()d("|cFF0000WARNING: |rRaidBuffsTank is no longer being developed, and its features have been added to RaidBuffs. Please download RaidBuffs for continued support, thank you.")end, 3000)
    RB.Init()
  end
end

EVENT_MANAGER:RegisterForEvent(RB.name, EVENT_ADD_ON_LOADED, RB.onAddonLoaded)
